//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private GomMultiTopPro[] cacheGomMultiTopPro = null;

        private static GomMultiTopPro checkGomMultiTopPro = new GomMultiTopPro();

        /// <summary>
        /// Gom.Bang
        /// </summary>
        /// <returns></returns>
        public GomMultiTopPro GomMultiTopPro()
        {
            return GomMultiTopPro(Input);
        }

        /// <summary>
        /// Gom.Bang
        /// </summary>
        /// <returns></returns>
        public GomMultiTopPro GomMultiTopPro(Data.IDataSeries input)
        {
            if (cacheGomMultiTopPro != null)
                for (int idx = 0; idx < cacheGomMultiTopPro.Length; idx++)
                    if (cacheGomMultiTopPro[idx].EqualsInput(input))
                        return cacheGomMultiTopPro[idx];

            lock (checkGomMultiTopPro)
            {
                if (cacheGomMultiTopPro != null)
                    for (int idx = 0; idx < cacheGomMultiTopPro.Length; idx++)
                        if (cacheGomMultiTopPro[idx].EqualsInput(input))
                            return cacheGomMultiTopPro[idx];

                GomMultiTopPro indicator = new GomMultiTopPro();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                GomMultiTopPro[] tmp = new GomMultiTopPro[cacheGomMultiTopPro == null ? 1 : cacheGomMultiTopPro.Length + 1];
                if (cacheGomMultiTopPro != null)
                    cacheGomMultiTopPro.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheGomMultiTopPro = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Gom.Bang
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GomMultiTopPro GomMultiTopPro()
        {
            return _indicator.GomMultiTopPro(Input);
        }

        /// <summary>
        /// Gom.Bang
        /// </summary>
        /// <returns></returns>
        public Indicator.GomMultiTopPro GomMultiTopPro(Data.IDataSeries input)
        {
            return _indicator.GomMultiTopPro(input);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Gom.Bang
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.GomMultiTopPro GomMultiTopPro()
        {
            return _indicator.GomMultiTopPro(Input);
        }

        /// <summary>
        /// Gom.Bang
        /// </summary>
        /// <returns></returns>
        public Indicator.GomMultiTopPro GomMultiTopPro(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.GomMultiTopPro(input);
        }
    }
}
#endregion
